// ok
#include <stdio.h>
#include <iostream>
#include <fstream>
#include <vector>
#include <bitset>
#include <cmath>
using namespace std;

struct InputStream {
	int Lim = 1 << 16;
    FILE *fin;
    char *buff;
    int p;
    
    char read_ch()
    {
        if (++p == Lim)
            p = 0, fread(buff, 1, Lim, fin);
        return buff[p];
    }

	InputStream(const char* fileName) :
		fin {fopen(fileName, "r")},
		buff {new char[Lim]},
		p {Lim - 1}
    {}

    ~InputStream()
    {
        fclose(fin);
        delete[] buff;
    }

    InputStream& operator >> (int& n)
    {
        char c;
        while (!isdigit(c = read_ch()) && c != '-');
        int sgn = 1;
        if (c == '-')
            n = 0, sgn = -1;
        else n = c - '0';
        while (isdigit(c = read_ch()))
            n = 10 * n + c - '0';
        n *= sgn;
        return *this;
    }
};

InputStream fin("connectthetree.in");
ofstream fout("connectthetree.out");

const int NMAX = 250005, LGMAX = 18;
int n, q, total, timer;
int aib[NMAX];
int t[LGMAX][NMAX];
int niv[NMAX];
int in[NMAX], out[NMAX];
bitset<NMAX> add;
vector<int> G[NMAX];

inline void DFS(int x);
inline int LCA(int x, int y);
inline void Update(int pos, int val);
inline int Count(int pos);

int main()
{
    fin >> n >> q;

    for (int i = 1, x, y; i < n; ++i)
    {
        fin >> x >> y;
        G[x].push_back(y);
        G[y].push_back(x);    
    }

    DFS(1);
    
    for (int i = 1; (1 << i) <= n; ++i)
		for (int j = 1; j <= n; ++j)
			t[i][j] = t[i - 1][t[i - 1][j]];
    
    // liniarizarea arborelui
    for (int i = 1; i <= n; ++i)
    {
        add[i] = 1;
        Update(in[i], 1);
        Update(out[i] + 1, -1);
    }

	int op, x, y;
    while (q--)
    {
        fin >> op >> x >> y;
        
        if (niv[x] < niv[y])  
            swap(x, y);          // "sterg" nodul de jos al muchiei

        if (op == 1)
        {
            add[x] = !add[x];  /// initial, true, deci adaug muchia [x y]  y = tata[x]
            if (add[x])        /// daca [x y] era "stearsa", introduc din nou pe x
            {
                Update(in[x], 1);
                Update(out[x] + 1, -1);
            }
            else                          /// stergem numai nodul fiu (x)
            {
                Update(in[x], -1);
                Update(out[x] + 1, 1);
            }
        }
        else
        {
            x = (x + total) % n + 1;
            y = (y + total) % n + 1;
            
            int lca = LCA(x, y);
            int sum = Count(in[x]) + Count(in[y]) - 2 * Count(in[lca]);
            
            int dist = niv[x] + niv[y] - 2 * niv[lca];
            if (sum == dist)
            {
                fout << "1\n";
                total++;
                if (total >= n)
                    total -= n;
            }
            else fout << "0\n";
        }
    }

    return 0;
}

inline void DFS(int x)
{
    in[x] = ++timer;
    for (int y : G[x])
        if (y != t[0][x])  
        {
            t[0][y] = x;
            niv[y] = niv[x] + 1;
            DFS(y);
        }
    out[x] = timer;
}

inline int LCA(int x, int y)
{
	// x trebuie sa aiba nivelul cel mai mare
	if (niv[x] < niv[y])
		swap(x, y);
    
    // aducem la acelasi nivel x si y
    int dif = niv[x] - niv[y];
    for (int i = 0; (1 << i) <= dif; ++i)
		if (dif & (1 << i))
			x = t[i][x];
    
    if (x == y) return x;
    
    for (int i = log2(niv[x]); i >= 0; --i)
        if (t[i][x] != t[i][y])
        {
            x = t[i][x];
            y = t[i][y];
        }
    return t[0][x];
}

inline void Update(int pos, int val)
{
    for (int i = pos; i <= n; i += i & -i)
        aib[i] += val;
}

inline int Count(int pos)
{
    int sum = 0;
    for (int i = pos; i >= 1; i -= i & -i)
        sum += aib[i];
    return sum;
}
