// ok
#include <stdio.h>
#include <iostream>
#include <fstream>
#include <vector>
#include <bitset>
#include <cmath>
#include <algorithm>
using namespace std;

struct InputStream {
	int Lim = 1 << 16;
    FILE *fin;
    char *buff;
    int p;
    
    char read_ch()
    {
        if (++p == Lim)
            p = 0, fread(buff, 1, Lim, fin);
        return buff[p];
    }

	InputStream(const char* fileName) :
		fin {fopen(fileName, "r")},
		buff {new char[Lim]},
		p {Lim - 1}
    {}

    ~InputStream()
    {
        fclose(fin);
        delete[] buff;
    }

    InputStream& operator >> (int& n)
    {
        char c;
        while (!isdigit(c = read_ch()) && c != '-');
        int sgn = 1;
        if (c == '-')
            n = 0, sgn = -1;
        else n = c - '0';
        while (isdigit(c = read_ch()))
            n = 10 * n + c - '0';
        n *= sgn;
        return *this;
    }
};

InputStream fin("connectthetree.in");
ofstream fout("connectthetree.out");

const int NMAX = 250005, LGMAX = 18;
int n, q, total, timer;
int st[4 * NMAX];
int t[LGMAX][NMAX];
int niv[NMAX];
int in[NMAX], out[NMAX];
bitset<NMAX> add;
vector<int> G[NMAX];

inline void DFS(int x);
inline int LCA(int x, int y);

// Nodul 1 al "aint" gestioneaza intervalul [1...n + 1] =>  Update(1, 1, n + 1, out[i] + 1, -1);
// out[i] + 1 poate fi pozitia n + 1
inline void Update(int x, int l, int r, int pos, int val);
inline int Count(int x, int l, int r, int a, int b);

int mx;
int main()
{
    fin >> n >> q;

    for (int i = 1, x, y; i < n; ++i)
    {
        fin >> x >> y;
        G[x].push_back(y);
        G[y].push_back(x);    
    }

    DFS(1);
   
    for (int i = 1; (1 << i) <= n; ++i)
		for (int j = 1; j <= n; ++j)
			t[i][j] = t[i - 1][t[i - 1][j]];
    
    for (int i = 1; i <= n; ++i)
    {
        add[i] = 1;
        Update(1, 1, n + 1, in[i], 1);
        Update(1, 1, n + 1, out[i] + 1, -1);
    }
    
	int op, x, y;
    while (q--)
    {
        fin >> op >> x >> y;
        if (op == 1)
        {
			
			if (niv[x] < niv[y])  
				swap(x, y);          // "sterg" nodul de jos al muchiei
            add[x] = !add[x];  /// initial, true, deci adaug muchia [x y]  y = tata[x]
            if (add[x])        /// daca [x y] era "stearsa", introduc din nou pe x
            {
                Update(1, 1, n + 1, in[x], 1); // adaug 1 pt X
                Update(1, 1, n  + 1, out[x] + 1, -1);
            }
            else                          /// stergem numai nodul fiu (x)
            {
		        Update(1, 1, n + 1, in[x], -1); 
                Update(1, 1, n + 1, out[x] + 1, 1);
            }
        }
        else
        {
            x = (x + total) % n + 1;
            y = (y + total) % n + 1;
            
            int lca = LCA(x, y);
            
            int sum = Count(1, 1, n + 1, 1, in[x]) + Count(1, 1, n + 1, 1, in[y]) - 2 * Count(1, 1, n + 1, 1, in[lca]);
			int dist = (niv[x] - niv[lca]) + (niv[y] - niv[lca]);  
		
            if (sum == dist)  // daca numarul de muchii intre x si y este egal cu distanta dintre x si y
            {
                fout << "1\n";
                total++;
			}
            else 
				fout << "0\n";    
        }
    }

    return 0;
}

inline void DFS(int x)
{
    in[x] = ++timer;
    for (int y : G[x])
        if (y != t[0][x])  
        {
            t[0][y] = x;
            niv[y] = niv[x] + 1;
            DFS(y);
        }
    out[x] = timer;
}

inline int LCA(int x, int y)
{
	if (niv[x] < niv[y])
		swap(x, y);
    
    int dif = niv[x] - niv[y];
    for (int i = 0; (1 << i) <= dif; ++i)
		if (dif & (1 << i))
			x = t[i][x];
    
    if (x == y) return x;
    
    for (int i = log2(niv[x]); i >= 0; --i)
        if (t[i][x] != t[i][y])
        {
            x = t[i][x];
            y = t[i][y];
        }
    return t[0][x];
}

inline void Update(int x, int l, int r, int p, int v)
{
    if (l == r)
    {
		st[x] += v;
		return;
	}
	int m = (l + r) / 2;
	if (p <= m)
		Update(2 * x, l, m, p, v);
	else
		Update(2 * x + 1, m + 1, r, p, v);
	st[x] = st[2 * x] + st[2 * x + 1];
}

inline int Count(int x, int l, int r, int a, int b)
{
    if (a <= l && r <= b)
		return st[x];
	int m = (l + r) / 2;
	int sum = 0;
	if (a <= m)
		sum = Count(2 * x, l, m, a, b);
	if (b > m)
		sum += Count(2 * x + 1, m + 1, r, a, b);
	return sum;
}
