/* Lowest Common Ancestor
   Complexitate:
 * O(n * log(n)) - Preprocesare
 * O(log(n)) / query
 */
#include <bits/stdc++.h>
using namespace std;

ifstream fin("lca.in");
ofstream fout("lca.out");

const int MAX_LOG = 17, MAX_N = 10005;
int anc[MAX_LOG][MAX_N];  // anc[i][x] = al 2^i lea stramos al lui x
int h[MAX_N];
vector<int> adj[MAX_N];
int n;
int Log;

void Dfs(int x)
{
    for (int y : adj[x])
    {
        if (y == anc[0][x]) continue;
        anc[0][y] = x;
        h[y] = h[x] + 1;
        Dfs(y);
    }
}

int LCA(int x, int y)
{
    if (h[x] < h[y])
        swap(x, y);    // acum x e pe un nivel mai mare decat y

	/// il aducem pe x la nivelul lui y
    int dif = h[x] - h[y];  /// dif = 2^7 + 2^3 + 2^1 + 2^0
    for (int i = 0; (1 << i) <= dif; ++i)
		if (dif & (1 << i))
			x = anc[i][x];


    if (x == y)  return x;

    for (int i = Log; i >= 0; i--)
        if (anc[i][x] != anc[i][y])
        {
            x = anc[i][x];
            y = anc[i][y];
        }
    /// acum x si y au acelasi tata: LCA
    return anc[0][x];   // returnam tata
}

int main()
{
	int x, y, q;
	fin >> n >> q;

	for (int i = 1; i < n; ++i)
	{
		fin >> x >> y;
		adj[x].push_back(y);
		adj[y].push_back(x);
	}

	Log = ceil(log2(n));
	Dfs(1);
	// dinamica
	for (int i = 1; (1 << i) <= n; ++i)
		for (int j = 1; j <= n; ++j)
			anc[i][j] = anc[i - 1][anc[i - 1][j]];

	while (q--)
	{
		fin >> x >> y;
		fout << "lca(" << x << ", " << y << ") = " << LCA(x, y) << '\n';
	}

    return 0;
}
