// OK
/* Complexitate:
 * O(n * log(n)) - Preprocesare
 * O(log(n)) / query
 */
#include <bits/stdc++.h>
using namespace std;

ifstream fin("lca.in");
ofstream fout("lca.out");

const int MAX_LOG = 17, MAX_N = 10005;
int anc[MAX_LOG][MAX_N];  // anc[i][x] = al 2^i lea stramos al lui x
int h[MAX_N];
vector<int> adj[MAX_N];
int n;
int Log;

void Dfs(int x, int fa)  /// O(n * log(n))
{
    anc[0][x] = fa;
    for (int i = 1; i <= Log; i++)
        anc[i][x] = anc[i - 1][anc[i - 1][x]];
    h[x] = h[fa] + 1;

    for (int y : adj[x])
    {
        if (y == fa) continue;
        Dfs(y, x);
    }
}

int LCA(int x, int y)
{
    if (h[x] < h[y])
        swap(x, y);

    for (int i = Log; i >= 0; i--)
        if (h[x] - (1 << i) >= h[y])
            x = anc[i][x];

    if (x == y)  return x;

    for (int i = Log; i >= 0; i--)
        if (anc[i][x] != anc[i][y])
        {
            x = anc[i][x];
            y = anc[i][y];
        }

    return anc[0][x];
}

int main()
{
	int x, y, q;
	fin >> n >> q;

	for (int i = 1; i < n; ++i)
	{
		fin >> x >> y;
		adj[x].push_back(y);
		adj[y].push_back(x);
	}

	Log = ceil(log2(n));
	Dfs(1, 1);   /// ATENTIE! DF(root, root)

	while (q--)
	{
		fin >> x >> y;
		fout << "lca(" << x << ", " << y << ") = " << LCA(x, y) << '\n';
	}

    return 0;
}
