// OK
/* Complexitate:
 * O(n * log(n)) - Preprocesare
 * O(log(n)) / query
 */ 
#include <fstream>
#include <cmath>
#include <vector>
using namespace std;
using VI  = vector<int>;
using VVI  = vector<VI>;
ifstream fin("lca.in");
ofstream fout("lca.out");

int n, Log;
VVI adj;

int timer;
VI tin, tout;
VVI anc;  // anc[i][x] = al 2^i - lea stramos al lui x

void Dfs(int x, int fa)
{
    tin[x] = ++timer;
    anc[0][x] = fa;
    for (int i = 1; i <= Log; ++i)
        anc[i][x] = anc[i - 1][anc[i - 1][x]];

    for (int y : adj[x]) 
    {
        if (y == fa) continue;
        Dfs(y, x);
    }

    tout[x] = ++timer;
}

bool IsAncestor(int x, int y)  // x este stramos al lui y
{
    return tin[x] <= tin[y] && tout[y] <= tout[x];
}

int LCA(int x, int y)
{
    if (IsAncestor(x, y)) return x;
    if (IsAncestor(y, x)) return y;
    
    for (int i = Log; i >= 0; --i) 
        if (!IsAncestor(anc[i][x], y))
            x = anc[i][x];
    
    return anc[0][x];
}

void Preprocess(int root) 
{
    tin = tout = VI(n + 1);
    Log = ceil(log2(n));
    anc = VVI(Log + 1, VI(n + 1));
    Dfs(root, root);  // ! aici trebuie root! (altfel nu se completeaza corect tabela anc)
}

int main()
{
	int x, y, q;
	fin >> n >> q;
	adj = VVI(n + 1);
	
	for (int i = 1; i < n; ++i)
	{
		fin >> x >> y;
		adj[x].push_back(y);
		adj[y].push_back(x);
	}
	
	Preprocess(1);
	while (q--)
	{
		fin >> x >> y;
		fout << "lca(" << x << ", " << y << ") = " << LCA(x, y) << '\n';
	}
}
