// infoarena
#include <fstream>
#include <algorithm>
#include <vector>
using namespace std;

ifstream fin("atac.in");
ofstream fout("atac.out");

#define NMAX 32005

vector<int> G[NMAX];

int str[20][NMAX], dp[20][NMAX];
int nivel[NMAX];

void Dfs(int x) 
{
    for (int y: G[x]) 
    {
        nivel[y] = nivel[x] + 1;
        Dfs(y);
    }
}

int LCA(int x, int y) 
{
    int minim = 1e9;
    if (nivel[x] < nivel[y]) 
		swap(x, y);

    int dif = nivel[x] - nivel[y];
    for (int i = 0; (1 << i) <= dif; ++i) 
        if (dif & (1 << i)) 
        {
            minim = min(minim, dp[i][x]);
            x = str[i][x];
        }
    
    for (int i = 19; i >= 0; --i) 
        if (str[i][x] != str[i][y]) 
        {
            minim = min({minim, dp[i][x], dp[i][y]});
            
            x = str[i][x];
            y = str[i][y];
        }
    
    if (x != y) 
        minim = min(minim, min(dp[0][x], dp[0][y]));
    
    if (minim == 1e9) 
        minim = 0;
    
    return minim;
}

int main() 
{
    int n, m, p;
    int u, v;
    fin >> n >> m >> p;
    for (int i = 2; i <= n; ++i) 
    {
        fin >> u >> v;
        str[0][i] = u;
        dp[0][i] = v;
        G[u].push_back(i);
    }
    
    int x, y, a, b, c, d;
    fin >> x >> y >> a >> b >> c >> d;

    for (int i = 1; (1 << i) <= n; ++i) 
        for (int j = 1; j <= n; ++j) 
        {
            if (str[i - 1][j]) 
                str[i][j] = str[i - 1][str[i - 1][j]];
            
            if (dp[i - 1][j]) 
                dp[i][j] = min(dp[i - 1][str[i - 1][j]], dp[i - 1][j]);
        }

    nivel[1] = 1;
    Dfs(1);

    for (int i = 1; i <= m; ++i) 
    {
        int nr = LCA(x, y);
        x = (x * a + y * b) % n + 1;
        y = (y * c + nr * d) % n + 1;
        if (i >= m - p + 1) {
            fout << nr << '\n';
        }
    }
    return 0;
}
