// ok
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <vector>
#include <vector>
#include <cctype>
#include <cmath>
using namespace std;

FILE *fin = fopen("viteza.in","r");
FILE *fout = fopen("viteza.out","w");

const int LGMAX = 17;
const int NMAX = 1e5;
const int MMAX = 1e5;

struct Query {
	int x, y, k;       
	int id;
	
    // sortam crescator dupa valoarea k si la valori egale, update-urile vin inaintea query-urilor
	bool operator < (const Query &q) const
	{
		if (k < q.k || (k == q.k && y < q.y))    // daca e update pe nod, y = 0
			return true;
		return false;
	}

	bool IsQuery()
	{
		return y != 0;
	}
};

int n,m;
vector<Query> queries;
vector<int> G[NMAX + 1];

int L[NMAX + 1];       // timpii de descoperire ai nodurilor
int R[NMAX + 1];       // timpii de terminare
int timer;               // In
int anc[LGMAX + 1][NMAX + 1]; // stramosii
int lv[NMAX + 1];

int aib[NMAX + 5];
int ans[NMAX + 5]; // ans[i] = raspunsul la intrebarea i
int v[NMAX + 5];   // valorile asociate nodurilor

void Update(int pos, int val);  // aib - update
// Sum(L[x]) returneaza numarul de noduri pe lantul de la radacina la nodul x, care au costul mai mic sau egal cu k din query-ul curent 
int Sum(int pos);               // aib - query   
void Dfs(int x, int tata);
int LCA(int x, int y);
int GetInt();                   // parsarea intrarii

int main()
{
    n = GetInt();
    m = GetInt();
	int x, y;
    for (int i = 1; i < n; ++i)
    {
        x = GetInt();
        y = GetInt();
        G[x].push_back(y);
        G[y].push_back(x);
    }

    Dfs(1, 0);

    for (int i = 1; (1 << i) <= n; ++i)
        for(int j = 1; j <= n; ++j)
            anc[i][j] = anc[i - 1][anc[i - 1][j]];

    for (int x = 1; x <= n; ++x)
    {
        v[x] = GetInt();
        queries.emplace_back(x, 0, v[x], 0);
    }
	
    for (int i = 1, k; i <= m; ++i)
    {
        x = GetInt();
        y = GetInt();
        k = GetInt();
        queries.emplace_back(x, y, k, i);
    }

    sort(queries.begin(),queries.end());
    
	int lca = 0;
    for (auto q : queries)
        if (q.IsQuery())
        {
            x = q.x;
            y = q.y;
            lca = LCA(x, y);
            ans[q.id] = Sum(L[x]) + Sum(L[y]) - 2 * Sum(L[lca]) + (v[lca] <= q.k);
        }
        else
        {
			// update pt toate nodurile cu valoarea k urmatoare
            Update(L[q.x], 1);
            Update(R[q.x] + 1, -1);
        }

    for (int i = 1; i <= m; ++i)
        fprintf(fout, "%d\n", ans[i]);
 
    fclose(fin);
    fclose(fout);

    return 0;
}

void Dfs(int x, int father)
{
    lv[x] = lv[father] + 1;
    anc[0][x] = father;
    L[x] = ++timer;
    
    for (int const& y : G[x])
    {
        if (y == father)  continue;
        Dfs(y, x);
    }
    
    R[x] = timer;
}

void Update(int pos, int val)
{
    for (int i = pos; i <= n; i += i & -i)
        aib[i] += val;
}

int Sum(int pos)
{
    int sum = 0;
    for (int i = pos; i; i -=  i & -i)
        sum += aib[i];
    
    return sum;
}

inline int LCA(int x, int y)
{
	// x trebuie sa aiba nivelul cel mai mare
	if (lv[x] < lv[y])
		swap(x, y);
    
    // aducem la acelasi nivel x si y
    int dif = lv[x] - lv[y];
    for (int i = 0; (1 << i) <= dif; ++i)
		if (dif & (1 << i))
			x = anc[i][x];
    
    if (x == y) return x;
    
    for (int i = log2(lv[x]); i >= 0; --i)
        if (anc[i][x] != anc[i][y])
        {
            x = anc[i][x];
            y = anc[i][y];
        }
    return anc[0][x];
}

const int LIM = 1 << 17;
char buff[LIM];
int ind = LIM - 1;

int GetInt()
{
    int nr = 0;
    while (!isdigit(buff[ind]))
        if (++ind >= LIM)
        {
            ind = 0;
            fread(buff, 1, LIM, fin);
        }

    while (isdigit(buff[ind]))
    {
        nr = nr * 10 + (buff[ind] - '0');
        if (++ind >= LIM)
        {
            ind = 0;
            fread(buff, 1, LIM, fin);
        }
    }
    return nr;
}
