#include <fstream>
#include <vector>
using namespace std;

ifstream fin("stramosi.in");
ofstream fout("stramosi.out");

const int Nmax = 250005, Mmax = 300005;

using VI  = vector<int>;
using VVI = vector<VI>;
using PI  = pair<int, int>;
using VP  = vector<PI>;
using VVP = vector<VP>;

VVI arb;
VVP queries;
VI path;
VI sol;

void dfs(int node)
{
    path.push_back(node);

    for (auto [k, i] : queries[node])
    {
        int idx = path.size() - 1 - k;
        if (idx >= 0)
            sol[i] = path[idx];
    }

    for (int son : arb[node])
        dfs(son);

    path.pop_back();
}

int main()
{
    int n, m;
    fin >> n >> m;
    queries = VVP(n + 1);
    arb = VVI(n + 1);
    sol = VI(m + 1);

    for (int fiu = 1, tata; fiu <= n; ++fiu)
    {
        fin >> tata;
        arb[tata].push_back(fiu);
    }

    // Offline:
    for (int i = 1, x, k; i <= m; ++i)
    {
        fin >> x >> k;
        queries[x].emplace_back(k, i);
    }

	
    dfs(0);

    for(int i = 1; i <= m; ++i)
        fout << sol[i] << '\n';

    return 0;
}
